/*
 * JBoss, Home of Professional Open Source
 * Copyright 2010, Red Hat Middleware LLC, and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.portal.portlet.samples;

import java.io.IOException;

import javax.portlet.GenericPortlet;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.portal.mop.SiteKey;
import org.exoplatform.portal.mop.SiteType;
import org.exoplatform.portal.mop.page.PageKey;
import org.exoplatform.portal.mop.page.PageService;

/**
 * Reproducer for case 00793139
 */
public class ClonePagePortlet extends GenericPortlet {

	@Override
	public void doView(RenderRequest request, RenderResponse response)
			throws IOException {
		System.out.println("Attempt to clone the 'homepage'...");
		String output = "";
		try {
			ExoContainer exo = ExoContainerContext.getCurrentContainer();
			PageService pageService = ((PageService) exo
					.getComponentInstanceOfType(PageService.class));
					
		    // src page
			SiteKey srcSiteKey = new SiteKey(SiteType.PORTAL, "classic");
			PageKey srcPage = new PageKey(srcSiteKey, "homepage");
			
			// destination
			SiteKey dstSiteKey = new SiteKey(SiteType.GROUP, "/platform/users");
			
			pageService.clone(srcPage, dstSiteKey.page(srcPage.getName()));
			output = "Page " + srcPage + " cloned with success to " + dstSiteKey;
		} catch (Exception e) {
			e.printStackTrace();
			output = "Not able to clone the page, see console";
		}
		response.getWriter().write(output);
	}
}
